//*****************************************
// AT mega328 Pulse Output Program
// CPU Clock:20MHz
//   iq[Yf[^@WȂBOIV[^(8MHz--)ɂj
//
// File Name:display.c
//
//  2016/02/26 Taishi
//*****************************************

#include	"pulse.h"
#include	"lcd.h"
#include	"utility.h"
#include	"timer.h"
#include	"display.h"

// set_mode_num Ɠ
static	unsigned char	disp_pos_xy[MAX_SET_MODE]={		// D7--D4:x(0--15), D3--D0:y(0 or 1)
	 1*16 + 0,	//ON_NUM_2,
	 2*16 + 0,	//ON_NUM_1,
	 3*16 + 0,	//ON_NUM_0,
	 5*16 + 0,	//PRID_NUM_3,
	 6*16 + 0,	//PRID_NUM_2,
	 7*16 + 0,	//PRID_NUM_1,
	 8*16 + 0,	//PRID_NUM_0,
	10*16 + 0,	//UNIT_SEL,
};
static	unsigned char	disp_pos_xy_run={ 6*16 + 1};	// D7--D4:x(0--15), D3--D0:y(0 or 1)

#if	CPU_CLOCK == 20
// 20MHz
static	unsigned char	str_unit[N_of_PULSE_UNIT+1][7]={
	{' ','5','0','n','S',' ',0},				// 1/1
	{'4','0','0','n','S',' ',0},				// 1/8
	{'3','.','2','u','S',' ',0},				// 1/64
	{'1','2','.','8','u','S',0},				// 1/256
	{'5','1','.','2','u','S',0},				// 1/1024
	{' ',' ',' ',' ',' ',' ',0},				//
};
#else
// 8MHz
static	unsigned char	str_unit[N_of_PULSE_UNIT+1][7]={
	{'1','2','5','n','S',' ',0},				// 1/1
	{' ',' ','1','u','S',' ',0},				// 1/8
	{' ',' ','8','u','S',' ',0},				// 1/64
	{' ','3','2','u','S',' ',0},				// 1/256
	{'1','2','8','u','S',' ',0},				// 1/1024
	{' ',' ',' ',' ',' ',' ',0},				//
};
#endif

static	unsigned char	str_run[3][6]={
	{'O','F','F',0},				// off
	{' ','O','N',0},				// on
	{' ',' ',' ',0},				// 
};

unsigned char	disp_moji[NofDispMoji+1];
static	char	dsp_buf[20];
// pXl̕\
void	disp_pulse_out(void)
{
	unsigned char	pos_x;
	unsigned char	pos_y;

	pos_x = (disp_pos_xy[ON_NUM_2] >> 4);
	pos_y = (disp_pos_xy[ON_NUM_2] & 0x0f);
	wtod_03u(dsp_buf,(unsigned int)pulse_out);
	disp_lcd(pos_x, pos_y, (unsigned char *)dsp_buf);
	disp_lcd(pos_x+3, pos_y, (unsigned char *)"/");
}

// pX̕\
void	disp_period(void)
{
	unsigned char	pos_x;
	unsigned char	pos_y;

	pos_x = (disp_pos_xy[PRID_NUM_3] >> 4);
	pos_y = (disp_pos_xy[PRID_NUM_3] & 0x0f);
	wtod_04u(dsp_buf,(unsigned int)pulse_period);
	disp_lcd(pos_x, pos_y, (unsigned char *)dsp_buf);
}

// pXPʂ̕\
void	disp_unit(void)
{
	unsigned char	pos_x;
	unsigned char	pos_y;

	pos_x = (disp_pos_xy[UNIT_SEL] >> 4);
	pos_y = (disp_pos_xy[UNIT_SEL] & 0x0f);
	disp_lcd(pos_x, pos_y, str_unit[pulse_unit]);
}

// Ԃ̕\
void	disp_run(void)
{
	unsigned char	pos_x;
	unsigned char	pos_y;

	pos_x = (disp_pos_xy_run >> 4);
	pos_y = (disp_pos_xy_run & 0x0f);
	disp_lcd(pos_x, pos_y, str_run[run]);
}

// uN̕\
//  blk : 1=Space, 0=Number
void	disp_blink(unsigned char blk)
{
	unsigned char	pos_x;
	unsigned char	pos_y;
	unsigned char	bf[2];

	pos_x = (disp_pos_xy[set_mode] >> 4);
	pos_y = (disp_pos_xy[set_mode] & 0x0f);
	if(blk == 1){				// 
		switch(set_mode){
		 case ON_NUM_2:
		 case ON_NUM_1:
		 case ON_NUM_0:
		 case PRID_NUM_3:
		 case PRID_NUM_2:
		 case PRID_NUM_1:
		 case PRID_NUM_0:
			bf[0] = ' ';
			bf[1] = 0;
			disp_lcd(pos_x, pos_y, bf);
			break;
		 case UNIT_SEL:
			disp_lcd(pos_x, pos_y, str_unit[N_of_PULSE_UNIT]);
			break;
		}
	}else{						// \鎞
		switch(set_mode){
		 case ON_NUM_2:
		 case ON_NUM_1:
		 case ON_NUM_0:
			wtod_03u(dsp_buf,(unsigned int)pulse_out);
			bf[0] = dsp_buf[set_mode - ON_NUM_2];
			bf[1] = 0;
			disp_lcd(pos_x, pos_y, bf);
			break;

		 case PRID_NUM_3:
		 case PRID_NUM_2:
		 case PRID_NUM_1:
		 case PRID_NUM_0:
			wtod_04u(dsp_buf,(unsigned int)pulse_period);
			bf[0] = dsp_buf[set_mode - PRID_NUM_3];
			bf[1] = 0;
			disp_lcd(pos_x, pos_y, bf);
			break;

		 case UNIT_SEL:
			disp_lcd(pos_x, pos_y, str_unit[pulse_unit]);
			break;
		}
	}
}

