//*****************************************
// AT mega328 Pulse Output Program
// CPU Clock:20MHz
//   iq[Yf[^@WȂBOIV[^(8MHz--)ɂj
//
// File Name:pulse.c
//
//  2016/02/26 Taishi
//  2016/08/05 Modify Switch --> Prev,Down,Up,Next,ON
//  2017/05/04 Modify Display "400uS" --> "400nS"
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pulse.h"
#include	"lcd.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"display.h"

unsigned char	set_mode=ON_NUM_2;
unsigned char	run=0;

// Õ[hɂ
void	prev_mode(void)
{
	unsigned char	uc;

	uc = set_mode;
	if(run == 1){				// 쒆
		switch(uc){
		 case ON_NUM_2:
		 	uc = ON_NUM_0;
			break;
		 case ON_NUM_1:
		 	uc = ON_NUM_2;
			break;
		 case ON_NUM_0:
		 	uc = ON_NUM_1;
			break;
		 case PRID_NUM_3:
		 case PRID_NUM_2:
		 case PRID_NUM_1:
		 case PRID_NUM_0:
		 case UNIT_SEL:
		 	uc = ON_NUM_2;
			break;
		}
	}else{						// ~
		switch(uc){
		 case ON_NUM_2:
		 	uc = UNIT_SEL;
			break;
		 case ON_NUM_1:
		 	uc = ON_NUM_2;
			break;
		 case ON_NUM_0:
		 	uc = ON_NUM_1;
			break;
		 case PRID_NUM_3:
		 	uc = ON_NUM_0;
			break;
		 case PRID_NUM_2:
		 	uc = PRID_NUM_3;
			break;
		 case PRID_NUM_1:
		 	uc = PRID_NUM_2;
			break;
		 case PRID_NUM_0:
		 	uc = PRID_NUM_1;
			break;
		 case UNIT_SEL:
		 	uc = PRID_NUM_0;
			break;
		}
	}

	set_mode = uc;
}

// ̃[hɂ
void	next_mode(void)
{
	unsigned char	uc;

	uc = set_mode;
	if(run == 1){				// 쒆
		switch(uc){
		 case ON_NUM_2:
		 	uc = ON_NUM_1;
			break;
		 case ON_NUM_1:
		 	uc = ON_NUM_0;
			break;
		 case ON_NUM_0:
		 	uc = ON_NUM_2;
			break;
		 case PRID_NUM_3:
		 case PRID_NUM_2:
		 case PRID_NUM_1:
		 case PRID_NUM_0:
		 case UNIT_SEL:
		 	uc = ON_NUM_2;
			break;
		}
	}else{						// ~
		switch(uc){
		 case ON_NUM_2:
		 	uc = ON_NUM_1;
			break;
		 case ON_NUM_1:
		 	uc = ON_NUM_0;
			break;
		 case ON_NUM_0:
		 	uc = PRID_NUM_3;
			break;
		 case PRID_NUM_3:
		 	uc = PRID_NUM_2;
			break;
		 case PRID_NUM_2:
		 	uc = PRID_NUM_1;
			break;
		 case PRID_NUM_1:
		 	uc = PRID_NUM_0;
			break;
		 case PRID_NUM_0:
		 	uc = UNIT_SEL;
			break;
		 case UNIT_SEL:
		 	uc = ON_NUM_2;
			break;
		}
	}

	set_mode = uc;
}

// f[^vX
void	plus_data(void)
{
	switch(set_mode){
	 case ON_NUM_2:
	 	if(((pulse_out + 100) <= PULSE_OUT_MAX)&&((pulse_out + 100) < pulse_period)){
		 	pulse_out += 100;
		}
		break;
	 case ON_NUM_1:
	 	if(((pulse_out + 10) <= PULSE_OUT_MAX)&&((pulse_out + 10) < pulse_period)){
		 	pulse_out += 10;
		}
		break;
	 case ON_NUM_0:
	 	if(((pulse_out + 1) <= PULSE_OUT_MAX)&&((pulse_out + 1) < pulse_period)){
		 	pulse_out += 1;
		}
		break;
	 case PRID_NUM_3:
	 	if((pulse_period + 1000) <= PULSE_PERIOD_MAX){
		 	pulse_period += 1000;
		}
		break;
	 case PRID_NUM_2:
	 	if((pulse_period + 100) <= PULSE_PERIOD_MAX){
		 	pulse_period += 100;
		}
		break;
	 case PRID_NUM_1:
	 	if((pulse_period + 10) <= PULSE_PERIOD_MAX){
		 	pulse_period += 10;
		}
		break;
	 case PRID_NUM_0:
	 	if((pulse_period + 1) <= PULSE_PERIOD_MAX){
		 	pulse_period += 1;
		}
		break;
	 case UNIT_SEL:
	 	if((pulse_unit + 1) < N_of_PULSE_UNIT){
		 	pulse_unit += 1;
		}
		break;
	}
}

// f[^}CiX
void	minus_data(void)
{
	switch(set_mode){
	 case ON_NUM_2:
	 	if(PULSE_OUT_MIN <= (pulse_out - 100)){
		 	pulse_out -= 100;
		}
		break;
	 case ON_NUM_1:
	 	if(PULSE_OUT_MIN <= (pulse_out - 10)){
		 	pulse_out -= 10;
		}
		break;
	 case ON_NUM_0:
	 	if(PULSE_OUT_MIN <= (pulse_out - 1)){
		 	pulse_out -= 1;
		}
		break;
	 case PRID_NUM_3:
	 	if(pulse_out < (pulse_period - 1000)){
		 	pulse_period -= 1000;
		}
		break;
	 case PRID_NUM_2:
	 	if(pulse_out < (pulse_period - 100)){
		 	pulse_period -= 100;
		}
		break;
	 case PRID_NUM_1:
	 	if(pulse_out < (pulse_period - 10)){
		 	pulse_period -= 10;
		}
		break;
	 case PRID_NUM_0:
	 	if(pulse_out < (pulse_period - 1)){
		 	pulse_period -= 1;
		}
		break;
	 case UNIT_SEL:
	 	if(0 <= (pulse_unit - 1)){
		 	pulse_unit -= 1;
		}
		break;
	}
}
// f[^o͑삷
void	output_data(void)
{
	if(run == 0){				// nee̎
		run = 1;				// nm
		switch(set_mode){
		 case ON_NUM_2:
		 case ON_NUM_1:
		 case ON_NUM_0:
			break;
		 default:
		 	set_mode = ON_NUM_2;
			break;
		}
	}else{						// nm̎
		run = 0;				// nee
	}
}
//*****************************************
// Main
//*****************************************
int	main(void)
{
	unsigned char	blink=0;
	unsigned char	old_run = 0xff;
	unsigned char	old_pulse_unit = 0xff;
	int				old_pulse_out = -1;
	int				old_pulse_period = -1;

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay
	init_lcd();										// Init. LCD

	disp_lcd(0,1,(unsigned char *)(__DATE__));		// s
	disp_lcd(0,0,(unsigned char *)(__TIME__));		// s

	sw_init();										// XCb`֌W̏ݒ
	led_init();										// kdc֌W̏ݒ
	timer1_init();									// Timer1 Initial
	timer2_init();									// Timer2 Initial

	delay_ms(2000);									// 2000mS Delay
	get_sw();

	disp_clear();
	old_run = run;
	disp_run();										// Ԃ̕\
	led_off();										// LED OFF
	old_pulse_out = pulse_out;
	disp_pulse_out();								// pXl̕\
	old_pulse_period = pulse_period;
	disp_period();									// pX̕\
	old_pulse_unit = pulse_unit;
	disp_unit();									// pXPʂ̕\
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	for(;;){
		get_sw();
		if(sw[2] != 0){											// ꂽXCb`L鎞
			if((sw[2] & SW_PREV) != 0){							// oqduXCb`nm̎
				disp_blink(0);									// uN̕\
				prev_mode();									// Õ[hɂ
			}else if((sw[2] & SW_NEXT) != 0){					// mdwsXCb`nm̎
				disp_blink(0);									// uN̕\
				next_mode();									// ̃[hɂ
			}else if((sw[2] & SW_DOWN) != 0){					// cnvmXCb`nm̎
				minus_data();									// f[^}CiX
			}else if((sw[2] & SW_UP) != 0){						// toXCb`nm̎
				plus_data();									// f[^vX
			}else if((sw[2] & SW_ON) != 0){						// nmXCb`nm̎
				disp_blink(0);									// uN̕\
				output_data();									// f[^o͑삷
			}
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;								// 500mS ԊuuN
			blink ^= 1;
			disp_blink(blink);									// uN̕\
		}

		if(old_run != run){
			old_run = run;
			disp_run();										// Ԃ̕\
			if(run == 1){
				pulse_on();
				led_on();									// LED ON
			}else{
				pulse_off();
				led_off();									// LED OFF
			}
		}

		if(old_pulse_unit != pulse_unit){
			old_pulse_unit = pulse_unit;
			disp_unit();									// pXPʂ̕\
		}

		if(old_pulse_out != pulse_out){
			old_pulse_out = pulse_out;
			disp_pulse_out();								// pXl̕\
			set_timer1_ontime();
		}

		if(old_pulse_period != pulse_period){
			old_pulse_period = pulse_period;
			disp_period();									// pX̕\
			set_timer1_period();
		}

	}
}
