//*****************************************
// AT mega328 Pulse Output Program
// CPU Clock:20MHz
//   iq[Yf[^@WȂBOIV[^(8MHz--)ɂj
//
// File Name:timer.h
//
//  2016/02/26 Taishi
//*****************************************

extern	void	delay_2us(unsigned char t);
extern	void	delay_ms(int tm);

// ************************ Timer 1 *************************
#define	PULSE_OUT_MIN			1
#define	PULSE_OUT_MAX			999	
#define	PULSE_OUT_DEFAULT		PULSE_OUT_MIN
#define	PULSE_PERIOD_MAX		1000
#define	PULSE_PERIOD_DEFAULT	1000
#define	PULSE_UNIT_DEFAULT		0
#define	N_of_PULSE_UNIT			5
#define	N_of_RUN_STAT			2
extern	int		pulse_out;
extern	int		pulse_period;
extern	int		pulse_unit;
extern	void	timer1_init(void);
extern	void	timer1_close(void);
extern	void	pulse_on(void);
extern	void	pulse_off(void);
extern	void	set_timer1_ontime(void);
extern	void	set_timer1_period(void);

// ************************ Timer 2 *************************
#if	CPU_CLOCK == 20
#define		COUNT_10MS		195											// about 10mS at 20MHz/1024 = 19531.25Hz(51.2uS)
#define		D_TCCR2B_10MS	((1 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (20MHz/1024= 19531.25Hz 51.2uS)
#else
#define		COUNT_1MS		125											// 1mS at 8MHz/64 = 125kHz(8uS)
#define		D_TCCR2B_1MS	((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (8MHz/64= 125kHz, 8uS)
#endif

#if	CPU_CLOCK == 20
#else
extern	unsigned char	tim_1ms;						// 10mSPʂJE^[
#endif
extern	unsigned char	tim_10ms;						// PbPʂJE^[
extern	unsigned char	tim_10ms_sw;					// XCb`͗pPOrPʃ^C}[
extern	unsigned char	tim_10ms_blink;					// \uNpPOrPʃ^C}[
extern	void			timer2_init(void);
extern	void			timer2_close(void);
